﻿using UnityEngine;
using System.Collections;

public class GameFlow : MonoBehaviour {

	public GUIStyle guiStyle;
	public GUIStyle guiStyle2;
	public GUIStyle guiStyle3;

	public int currentSnowBall;
	public SnowBall[] snowballs;

	public Transform endZone;

	public int strokes;

	private int points;
	private bool gameOver = false;
	private bool gameWon = false;

	private static GameFlow _instance;
	
	public static GameFlow instance{
		get{
			if(_instance == null){
				_instance = GameObject.FindObjectOfType<GameFlow>();
				// Tell Unity not to destroy this object when loading a new scene!
				//DontDestroyOnLoad(_instance.gameObject);
			}
			return _instance;
		}
	}

	// Use this for initialization
	void Start () {
		endZone = GameObject.Find("EndZone").transform;
	}
	
	// Update is called once per frame
	void Update () {
		guiStyle.fontSize = Screen.width / 15;
		guiStyle2.fontSize = Screen.width / 20;
		guiStyle3.fontSize = Screen.width / 25;

		if(Input.GetButtonUp("Jump")){
			gameOver = false;
			gameWon = false;
			strokes = 0;
			points = 0;
			Application.LoadLevel("Level01");
		}
		if(gameOver || gameWon){
			if (Application.platform == RuntimePlatform.Android){
				if(Input.GetMouseButton(0)){
					Application.LoadLevel("Level01");
				}
			}
		}
		if(Input.GetButton("Cancel")){
			Application.LoadLevel("start");
		}
	}

	void OnGUI(){
		GUI.Label(new Rect(0,0,Screen.width, Screen.height), "Strokes  " + strokes, guiStyle3);
		//GUI.Label(new Rect(10,10,200, 200), "Points  " + points, guiStyle);
		if(gameOver){
			GUI.Label(new Rect(0,0,Screen.width, Screen.height), "Oops...", guiStyle);
			GUI.Label(new Rect(0,guiStyle.fontSize,Screen.width, Screen.height), "Press space to restart", guiStyle2);
		}
		if(gameWon){
			GUI.Label(new Rect(0,0,Screen.width, Screen.height), "You did it!", guiStyle);
			GUI.Label(new Rect(0,guiStyle.fontSize,Screen.width, Screen.height), "Your snowman is worth " + points + " points", guiStyle2);
		}
	}

	public void nextBall(){
		if(currentSnowBall < snowballs.Length-1){
			currentSnowBall++;
			snowballs[currentSnowBall].collider2D.enabled = true;
			snowballs[currentSnowBall].rigidbody2D.isKinematic = false;
		}
	}

	private int calculatePoints(){
		float points = 0;
		for(int n = snowballs.Length-1 ; n > 0 ; n--){
			float percentage = (snowballs[n].transform.localScale.y / snowballs[n-1].transform.localScale.y) * 100;
			Debug.Log ("P: " + percentage);
			points += 100 - percentage;
		}
		return Mathf.RoundToInt(points) - (strokes);
	}


	public void finalBall(){
		points = calculatePoints();
		gameWon = true;
	}

	public void setGameOver(){
		gameOver = true;
	}
}
