﻿using UnityEngine;
using System.Collections;

public class Ground : MonoBehaviour {

	public LineRenderer lineRenderer;
	public Transform endZone;

	private EdgeCollider2D edgeCollider;

	// Use this for initialization
	void Start () {
		edgeCollider = (EdgeCollider2D) collider2D;
		createGround();
	}
	
	// Update is called once per frame
	void Update () {

		lineRenderer.SetVertexCount(edgeCollider.points.Length);
		for(int n = 0 ; n < edgeCollider.points.Length ; n++){
			Vector2 thisPoint = edgeCollider.points[n];
			lineRenderer.SetPosition(n, new Vector3(thisPoint.x + transform.position.x, thisPoint.y + transform.position.y));
		}
	}

	void OnDrawGizmos() {
		if(edgeCollider == null) edgeCollider = (EdgeCollider2D) collider2D;
		Gizmos.color = Color.blue;
		if(edgeCollider.points.Length > 1){

			for(int n = 1 ; n < edgeCollider.points.Length ; n++){
				Vector2 lastPoint = edgeCollider.points[n-1];
				Vector2 thisPoint = edgeCollider.points[n];
				Gizmos.DrawLine(new Vector3(lastPoint.x + transform.position.x, lastPoint.y + transform.position.y), 
				                new Vector3(thisPoint.x + transform.position.x, thisPoint.y + transform.position.y));
			}
		}
	}

	public void createGround(){
		Vector2[] points = new Vector2[37];

		for(int n = 0 ; n < points.Length ; n++){
			float lastY = 0;
			if(n > 0) lastY = points[n-1].y;

			float y = lastY + Random.Range (-2f,1f);
			if(y < -7.5f) y = -7.5f;

			if(n <= 6) y = 0;						// flat startlines
			if(n >= points.Length - 7) y = lastY;	// flat endlines
			if(n == points.Length - 1) y = lastY + 1; // stop point

			points[n] = new Vector2(n, y);
		}

		edgeCollider.points = points;

		// move endzone
		endZone.position = new Vector3(points[points.Length-4].x + transform.position.x, points[points.Length-4].y + 1.5f);
	}

}
